/*
 * Copyright © 2022 Soren Stoutner <soren@stoutner.com>.
 *
 * This file is part of Privacy Browser PC <https://www.stoutner.com/privacy-browser-pc>.
 *
 * Privacy Browser PC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Privacy Browser PC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Privacy Browser PC.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef USERAGENTHELPER_H
#define USERAGENTHELPER_H

// Qt framework headers.
#include <QString>

class UserAgentHelper
{
public:
    // The default constructor.
    UserAgentHelper();

    // The public constants.
    static const QString CHROMIUM_LINUX_DATABASE;
    static const QString CHROMIUM_LINUX_TRANSLATED;
    static const QString CHROMIUM_LINUX_USER_AGENT;
    static const QString CHROME_WINDOWS_DATABASE;
    static const QString CHROME_WINDOWS_TRANSLATED;
    static const QString CHROME_WINDOWS_USER_AGENT;
    static const QString EDGE_WINDOWS_DATABASE;
    static const QString EDGE_WINDOWS_TRANSLATED;
    static const QString EDGE_WINDOWS_USER_AGENT;
    static const QString FIREFOX_LINUX_DATABASE;
    static const QString FIREFOX_LINUX_TRANSLATED;
    static const QString FIREFOX_LINUX_USER_AGENT;
    static const QString FIREFOX_WINDOWS_DATABASE;
    static const QString FIREFOX_WINDOWS_TRANSLATED;
    static const QString FIREFOX_WINDOWS_USER_AGENT;
    static const QString PRIVACY_BROWSER_DATABASE;
    static const QString PRIVACY_BROWSER_TRANSLATED;
    static const QString PRIVACY_BROWSER_USER_AGENT;
    static const QString SAFARI_MACOS_DATABASE;
    static const QString SAFARI_MACOS_TRANSLATED;
    static const QString SAFARI_MACOS_USER_AGENT;
    static const QString SYSTEM_DEFAULT_DATABASE;
    static const QString SYSTEM_DEFAULT_TRANSLATED;

    // The public functions.
    static QString getUserAgentFromDatabaseName(const QString &userAgentDatabaseName);
    static QString getUserAgentFromTranslatedName(const QString &userAgentTranslatedName);
    static QString getDatabaseUserAgentName(const QString &translatedUserAgentName);
    static int getDomainSettingsUserAgentIndex(const QString &userAgentName);
    static QString getResultingDomainSettingsUserAgent(const QString &rawUserAgent);
    static QString getTranslatedUserAgentName(const QString &userAgentName);
};
#endif
